//Bar.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// This class is used to paint s custom icon that can be later used on a label
// It implements the class Icon and overrides methods paintIcon, getIconWidth, and getIconHeight


import javax.swing.Icon;
import java.awt.*;



public class Bar implements Icon {

	// h and w stand for height and width
	// r, g, b, are integer values that are passed in order to construcs a custom RGB color
	private int h, w, r, g, b;

	public Bar (int w, int h, int r, int g, int b) {
		this.h = h;
		this.w = w;
		this.r =r;
		this.g=g;
		this.b=b;
	}

    	public void paintIcon(Component c, Graphics gr, int x, int y) {

      gr.setColor(new Color (r, g, b));
	  gr.fillRect(x, y, w, h);
    	}

	public int getIconWidth() {
		return w;
	}

	public int getIconHeight() {
		return h;
	}
}