// PowerAndData.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// Displays information about both power and data collected
// created 06/10/05
//package bluetooth_project;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.util.Random;



public class EnergyAndData extends JFrame
{
	// declare and initialize variables

	private  int numberNodes = Global.numberNodes;
	private Node[] nodes_array = Global.nodes_array;
	Node myNode;

	private final int MAX = 100;
	JCheckBox[] nodes;
	JLabel[] energyL, dataL, visualEnergyL, visualDataL;
	JLabel[] dummy;
	JLabel text, red, blue;
	Container c;
	JPanel namesPanel, visualPanel, numbersPanel, legendPanel;
	JScrollPane scrollPane;
	Border raisedetched;
	boolean[] toggle = new boolean[numberNodes];
	Icon[] bar, bar1;
	Icon redI, blueI;
	JMenuBar menu;

	public EnergyAndData() {

	super ("Temperature and Energy Reading");
	this.setLocation(325, 200);		//place the frame on the desktop using the coordinates

	raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);

	c = getContentPane();
	c.setLayout (new BorderLayout (5,5));

	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	Random rand = new Random();

	for (int j=0; j<numberNodes; j++){
		toggle[j] = true;
	}

	//create a Legend area which shows the color-label relationship
	legendPanel = new JPanel();
	legendPanel.setLayout (new FlowLayout());
	legendPanel.setBorder(raisedetched);

	//create icons in the form of a colored bar that will be used to indicate the energy
	// and temperature level of each node

	text = new JLabel ("<html>Legend: <br></html>");
	red = new JLabel ("Energy Values");
	red.setIcon(new Bar(10, 10, 255, 0,0));
	blue = new JLabel ("Temperature Values");
	blue.setIcon(new Bar(10, 10, 0, 0,255));

	legendPanel.add(text);
	legendPanel.add(blue);
	legendPanel.add(red);

	namesPanel = new JPanel();
	namesPanel.setLayout (new GridLayout (numberNodes*2, 3));
	namesPanel.setBorder(raisedetched);

	scrollPane = new JScrollPane(namesPanel);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      scrollPane.setPreferredSize(new Dimension(410,360));

	c.add(scrollPane, BorderLayout.CENTER);
	c.add(legendPanel, BorderLayout.NORTH);

	//initialization of all arrays
	nodes = new JCheckBox[numberNodes];
	energyL = new JLabel [numberNodes];
	dataL = new JLabel [numberNodes];
	bar = new Icon[numberNodes];
	bar1 = new Icon[numberNodes];
	visualEnergyL = new JLabel [numberNodes];
	visualDataL = new JLabel [numberNodes];

	dummy = new JLabel [numberNodes];

	CheckBoxHandler handler = new CheckBoxHandler();

	// In this loop each JComponent is created and its value set.
	/* In order to maintain a pleasant interface we arrange the various labels and bars in two
	   rows for each node, and use an empty label to leave some space out. For each colored bar we set a ToolTip Text that gives the number to which the bar corresponds*/

	for (int i=0; i<numberNodes; i++) {
		myNode = nodes_array[i];
		nodes[i] = new JCheckBox ("Node " + (i+1), toggle[i]);
		nodes[i].addItemListener(handler);
		bar[i] = new Bar((int)Math.ceil (myNode.getEnergy()), 15, 255, 0,0);
		bar1[i] = new Bar ((int)Math.ceil (myNode.getData()), 15, 0,0,255);
		visualEnergyL[i] = new JLabel ("");
		visualDataL[i] = new JLabel ("");
		visualEnergyL[i].setIcon(bar[i]);
		visualDataL[i].setIcon(bar1[i]);
		visualEnergyL[i].setToolTipText("energy left: " + myNode.getEnergy());
		visualDataL[i].setToolTipText ("temperature read: " + myNode.getData());
		dataL [i] = new JLabel ("Temp: " + myNode.getData());
		dataL[i].setBorder (raisedetched);
		energyL[i] = new JLabel ("Energy: " + myNode.getEnergy());
		energyL[i].setBorder (raisedetched);
		dummy[i] = new JLabel ("");

		namesPanel.add (nodes[i]);
		namesPanel.add(visualDataL[i]);
		namesPanel.add (dataL[i]);
		namesPanel.add(dummy[i]);
		namesPanel.add(visualEnergyL[i]);
		namesPanel.add (energyL[i]);
			}

	//add a menu to the frame
	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);
	JMenu optionsMenu = new JMenu ("Options");
	menu.add (optionsMenu);
	JMenuItem select = new JMenuItem ("Select all");
	optionsMenu.add(select);
	select.addActionListener (new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
		for (int i=0; i<numberNodes; i++)
		{
			energyL[i].setVisible(true);
			visualEnergyL[i].setVisible(true);
			nodes[i].setSelected(true);
		}
	}
	}
	);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(EnergyAndData.this, "This application was created" + " in Summer 2005", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);

	//set up some frame prefferences, pack the frame, and display it on the screen
	setSize (425,425);
	setResizable(false);
	show();

	}

//the CheckBoxHandler is responsible for showing and hiding all information about a node, //depending on whether that node is checked or not

private class CheckBoxHandler implements ItemListener {

public void itemStateChanged (ItemEvent e)
{
	for (int i=0; i<numberNodes; i++)
	{
		if (e.getSource() == nodes[i])
		{
			energyL[i].setVisible(!toggle[i]);
			dataL[i].setVisible(!toggle[i]);
			visualEnergyL[i].setVisible(!toggle[i]);
			visualDataL[i].setVisible(!toggle[i]);
			toggle[i] = !toggle[i];
		}
	}
	c.validate();
}
}

}




